
; PicBasic Pro Compiler 2.10,  Copyright (c) 1998 microEngineering Labs, Inc.     All Rights Reserved.

PM_USED			EQU	1

	INCLUDE	"PBPPROC.INC"

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
T1              		EQU	RAM_START + 012h
T2              		EQU	RAM_START + 014h
FLAGS           		EQU	RAM_START + 016h
GOP             		EQU	RAM_START + 017h
RM1             		EQU	RAM_START + 018h
RM2             		EQU	RAM_START + 019h
RR1             		EQU	RAM_START + 01Ah
RR2             		EQU	RAM_START + 01Bh
_I               		EQU	RAM_START + 01Ch
_PORTL           		EQU	PORTB
_PORTH           		EQU	PORTA
_TRISL           		EQU	TRISB
_TRISH           		EQU	TRISA
#define _B0              	_PORTB_0
#define _B1              	_PORTB_1
#define _B2              	_PORTB_2
#define _B3              	_PORTB_3
#define _B4              	_PORTB_4
#define _PORTB_0         	PORTB, 000h
#define _PORTB_1         	PORTB, 001h
#define _PORTB_2         	PORTB, 002h
#define _PORTB_3         	PORTB, 003h
#define _PORTB_4         	PORTB, 004h

; Constants.
	INCLUDE	"TOFF-TON.MAC"
	INCLUDE	"PBPPIC14.LIB"

	CLEAR?	
	INPUT?T	_PORTB_0
	INPUT?T	_PORTB_1
	INPUT?T	_PORTB_2
	INPUT?T	_PORTB_3
	OUTPUT?T	_PORTB_4

	LABEL?L	_LOOP	
	CMPEQ?TCB	_B0, 000h, T1
	CMPEQ?TCB	_B1, 000h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00001
	GOSUB?L	_ON1
	LABEL?L	L00001	
	CMPEQ?TCB	_B0, 001h, T1
	CMPEQ?TCB	_B1, 000h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00003
	GOSUB?L	_ON2
	LABEL?L	L00003	
	CMPEQ?TCB	_B0, 000h, T1
	CMPEQ?TCB	_B1, 001h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00005
	GOSUB?L	_ON3
	LABEL?L	L00005	
	CMPEQ?TCB	_B0, 001h, T1
	CMPEQ?TCB	_B1, 001h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00007
	GOSUB?L	_ON4
	LABEL?L	L00007	
	CMPEQ?TCB	_B2, 000h, T1
	CMPEQ?TCB	_B3, 000h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00009
	GOSUB?L	_OFF1
	LABEL?L	L00009	
	CMPEQ?TCB	_B2, 001h, T1
	CMPEQ?TCB	_B3, 000h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00011
	GOSUB?L	_OFF2
	LABEL?L	L00011	
	CMPEQ?TCB	_B2, 000h, T1
	CMPEQ?TCB	_B3, 001h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00013
	GOSUB?L	_OFF3
	LABEL?L	L00013	
	CMPEQ?TCB	_B2, 001h, T1
	CMPEQ?TCB	_B3, 001h, T2
	LAND?BBW	T1, T2, T2
	CMPF?WL	T2, L00015
	GOSUB?L	_OFF4
	LABEL?L	L00015	
	GOTO?L	_LOOP

	LABEL?L	_ON1	
	MOVE?CB	001h, _I
	LABEL?L	L00017	
	CMPGT?BCL	_I, 002h, L00018
	MOVE?CT	001h, _PORTB_4
	PAUSE?C	07530h
	NEXT?BCL	_I, 001h, L00017
	LABEL?L	L00018	
	RETURN?	

	LABEL?L	_ON2	
	MOVE?CB	001h, _I
	LABEL?L	L00019	
	CMPGT?BCL	_I, 004h, L00020
	MOVE?CT	001h, _PORTB_4
	PAUSE?C	061A8h
	NEXT?BCL	_I, 001h, L00019
	LABEL?L	L00020	
	RETURN?	

	LABEL?L	_ON3	
	MOVE?CB	001h, _I
	LABEL?L	L00021	
	CMPGT?BCL	_I, 008h, L00022
	MOVE?CT	001h, _PORTB_4
	PAUSE?C	061A8h
	NEXT?BCL	_I, 001h, L00021
	LABEL?L	L00022	
	RETURN?	

	LABEL?L	_ON4	
	MOVE?CB	001h, _I
	LABEL?L	L00023	
	CMPGT?BCL	_I, 010h, L00024
	MOVE?CT	001h, _PORTB_4
	PAUSE?C	061A8h
	NEXT?BCL	_I, 001h, L00023
	LABEL?L	L00024	
	RETURN?	

	LABEL?L	_OFF1	
	MOVE?CB	001h, _I
	LABEL?L	L00025	
	CMPGT?BCL	_I, 004h, L00026
	MOVE?CT	000h, _PORTB_4
	PAUSE?C	061A8h
	NEXT?BCL	_I, 001h, L00025
	LABEL?L	L00026	
	RETURN?	

	LABEL?L	_OFF2	
	MOVE?CB	001h, _I
	LABEL?L	L00027	
	CMPGT?BCL	_I, 008h, L00028
	MOVE?CT	000h, _PORTB_4
	PAUSE?C	04E20h
	NEXT?BCL	_I, 001h, L00027
	LABEL?L	L00028	
	RETURN?	

	LABEL?L	_OFF3	
	MOVE?CB	001h, _I
	LABEL?L	L00029	
	CMPGT?BCL	_I, 014h, L00030
	MOVE?CT	000h, _PORTB_4
	PAUSE?C	061A8h
	NEXT?BCL	_I, 001h, L00029
	LABEL?L	L00030	
	RETURN?	

	LABEL?L	_OFF4	
	MOVE?CB	001h, _I
	LABEL?L	L00031	
	CMPGT?BCL	_I, 018h, L00032
	MOVE?CT	000h, _PORTB_4
	PAUSE?C	061A8h
	NEXT?BCL	_I, 001h, L00031
	LABEL?L	L00032	
	RETURN?	
	END?	

	END
